Attribute VB_Name = "mWorker"
Option Explicit


'this routine is called from Sub Main - and generic for cIPCWorker-based Modules (the concrete stuff happens in DoJob below)
Public Sub EnterWorkerLoop(W As cIPCWorker, JobKey As String)
    If W.InitWithCommandLineJobKey(JobKey) Then
        Do Until W.MasterWantsToClose
            If W.WaitForNextPreparedJob Then DoJob W    'do specific Job-Processing
        Loop
    End If
End Sub


Private Sub DoJob(W As cIPCWorker)

    Dim X   As Long
    Dim Y   As Long
    Dim X2  As Long
    Dim Y2  As Long
    Dim I   As Long


    Dim vout() As Single
    Dim vIN() As Single

    Static p As tWorkArea

    Dim Area As Long

    W.UserDataRead VarPtr(p), LenB(p)
    ReDim vIN(p.W, p.H)

    Area = (p.W + 1) * (p.H + 1) * 4
    W.UserDataRead VarPtr(vIN(0, 0)), Area, LenB(p)


    ReDim vout(p.W, p.H)
    For I = 1 To 100    ' just to stress cpu
        For Y = p.StartY To p.EndY
            Y2 = Y - 15: If Y2 < 0 Then Y2 = 0
            For X = 0 To p.W
                X2 = X - 15: If X2 < 0 Then X2 = 0
                vout(X, Y) = Abs(vIN(X, Y) - vIN(X2, Y2)) * 2
            Next
            If W.MasterWantsToClose Or W.JobState <> wjobProcessing Then Exit Sub    'early exit
        Next
    Next

    W.UserDataWrite VarPtr(vout(0, 0)), Area, LenB(p) + Area

    W.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub



